#include <stdio.h>
#include <math.h>

int showAllFlag = 0;

void exit( int );


main( int argc, char **argv )
{
	int istat;
	unsigned char data[5];
	FILE *fin;
	
	showAllFlag = argc > 1;
	
	fin = fopen( "logfile.dat", "r" );
	
	if( fin == NULL ) {
		printf("Can't open logfile.dat\n");
		exit( 1 );
	}
	
	while( 1 ) {
		istat = fread( data, 1, 5, fin );
	
		if( feof( fin ) ) break;
	
		if( istat != 5 ) {
			printf("Ooops, istat = %d\n", istat );
			continue;
		}
		
		decode( data );
	}
	
//	printMap();
	
}


int startTime = -1;
int iTimePrev = -1;
int iTimeOffset = 0;
float lastTime;
int red, blue, green;

char theStands[5] = { ' ', ' ', ' ', ' ', ' ' };
char theRail[8] = { 'x', 'x', 'x', 'x',  'x', 'x', 'x', 'x' };
char colorTable[7] = { 'N', 'b', 'B', 'G', 'Y', 'R', 'w' };

int whereIsTheArm;
int gotaBall;
char ballColor = ' ';


char theRealStands[4] = { ' ', ' ', ' ', ' ' };
char theRealRail[8]   = { ' ', ' ', ' ', ' ',  ' ', ' ', ' ', ' ' };


decode( unsigned char *data )
{
	int i, it, iType, iTime;
	int iMotor, iOverload, cmdPower, thePower;
	short iValue;
	char theColor;
	float tmp, time;
	
	iType = data[0];
	
	iTime  = data[1] | (data[2]<<8);
	iValue = data[3] | (data[4]<<8);
	
	if( iTimePrev > iTime ) iTimeOffset += (1 << 16);
	iTimePrev = iTime;
	iTime += iTimeOffset;
	
	if( !showAllFlag ) {
		if( iType ==  3 ) {
			printf("\n");
			return;
		}
		if( iType ==  6  ||  iType ==  7 ) return;
		if( iType >= 20  &&  iType <= 27 ) return;
		if( iType == 33                  ) return;
		if( iType == 34                  ) return;
		if( iType == 59                  ) return;
	}
	
	if( iType == 1  ||  iType == 3 ) printf("\n");
	
	if( startTime < 0 ) {
		startTime = iTime;
		lastTime  = -1.0;
	}

	time = 0.001 * (iTime - startTime );
	
	if( iType != 36  &&  iType != 37  &&  iType != 51  &&  iType != 52  &&  iType != 53 ) {

		if( time == lastTime )
			printf("          ");
		else
			printf(" %7.3f: ", time );
		lastTime = time;
	}
	
	switch( iType ) {
			
	case 1:
		printf("sortState: %d\n", iValue );
		break;
		
	case 3:
		printf("LoopCnt %3d\n", iValue );
		break;
	
	case 4:
		printf("Error %2d\n", iValue );
		break;
	
	case 5:
		printf("iStation: %d\n", iValue );
		break;
	
	case 6:
		printf("Turn value %4d\n", iValue );
		break;
	
	case 7:
		printf("Rotate error %d\n", iValue );
		break;
	
	case 10:
		printf("Start rotate: %3d\n", iValue );
		break;
	
	case 11:
		printf("Start the motor: %3d\n", iValue );
		break;
	
	case 12:
		printf("Motor stopped: %3d\n", iValue );
		break;
	
	case 13:
		printf("Stop rotate: %3d\n", iValue );
		break;
	
	case 8:
		printf("Placement error %d\n", iValue );
		break;
	
	case 20:
		printf("Close: %d\n", iValue );
		break;
	
	case 21:
		printf("Open: %d\n", iValue );
		break;
	
	case 25:
		printf("Fall: %d\n", iValue );
		break;
	
	case 26:
		printf("Rise: %d\n", iValue );
		break;

	case 30:
		printf("Num occuppied %d\n", iValue );
		break;

	case 31:
		printf("iWhich %d\n", iValue );
		break;

	case 32:
		printf("Num occuppied %d\n", iValue );
		break;
		
	case 33:
		printf("NumBallsFound %d\n", iValue );
		break;
		
	case 34:
		printf("colorcount[%d] = %d\n", iValue >> 8, iValue & 0xFF );
		break;
	
	case 35:
		printf("numBallsOnRail %d\n", iValue );
		break;
	
	case 36:
		i = iValue >> 8;
		if( i < 0  ||  i > 7 ) {
			printf("Ooops: bad realRail index %d\n", i );
			break;
		}
		it = iValue & 0xFF;
		theColor = 'x';
		if( it == 0xFF ) theColor = ' ';
		if( it >=1  &&  it <= 6 ) theColor = colorTable[it];
		theRealRail[i] = theColor;
		if( i < 7 ) break;
		printf("The realrail: [");
		for( i=0; i<8; i++ ) {
			if( i != 0 ) printf("_");
			printf("%c", theRealRail[i]);
		}
		printf("]  ");
		break;
	
	case 37:
		i = iValue >> 8;
		if( i < 0  ||  i > 3 ) {
			printf("Ooops: bad stand index %d\n", i );
			break;
		}
		it = iValue & 0xFF;
		theColor = 'x';
		if( it == 0xFF ) theColor = ' ';
		if( it >=0  &&  it <= 6 ) theColor = colorTable[it];
		theRealStands[i] = theColor;
		if( i < 3 ) break;
		printf("The Stands: [");
		for( i=0; i<4; i++ ) {
			if( i != 0 ) printf("_");
			printf("%c", theRealStands[i] );
		}
		printf("]\n");
		break;

	case 38:
		printf("Total known balls %d, nbs %d, ntbor %d, nos %d\n",
			iValue/1000, (iValue/100)%10, (iValue/10)%10, iValue%10 );
		break;

	case 40:
		printf("Last placed %d\n", iValue );
		break;

	case 41:
		printf("Remove last placed at %d\n", iValue );
		break;
	
	case 50:
		printf("Color: %3d, rgb ( %3d %3d %3d)\n", iValue, red, blue, green );
		break;
		
	case 51:
		red = iValue;
		break;
	
	case 52:
		blue = iValue;
		break;
	
	case 53:
		green = iValue;
		break;
	
	case 59:
		printf("Test: iWhere %d, color %d, low color %d\n", iValue/100, (iValue/10)%10, iValue%10 );
		break;
	
	case 60:
		printf("Invalidate %d, tbc %d, lbr %d\n", iValue/100, (iValue/10)%10, iValue%10 );
		break;
	
	case 61:
		printf("True number of balls %d\n", iValue );
		break;
	
	case 62:
		printf("rail2 lbr: iRail %d, inx %d, bc %d\n",
			iValue/100, (iValue/10)%10, (iValue%10)-1 );
		break;
	
	case 63:
		printf("Invalidate2 %d, tbc %d, lbr %d\n", iValue/100, (iValue/10)%10, iValue%10 );
		break;
	
	case 64:
		printf("Invalidate %d, nbc %d\n", iValue/10, iValue%10 );
		break;
	
	case 65:
		printf("Num balls skipped %d\n", iValue );
		break;
	
	case 66:
		printf("Num excess balls skipped %d (%d %d)\n", iValue/100, (iValue/10)%10, iValue%10 );
		break;
	
	case 70:
		printf("shortcut: iwhere %d, tbc %d, wc %d\n",
			iValue/100, (iValue/10)%10, iValue%10 );
		break;
		
	case 71:
		printf("fhs: iwhich %d, hc %d\n", iValue/10, iValue%10 );
		break;
	
	case 72:
		printf("600: rail0 %d, hc %d\n", iValue/10, iValue%10 );
		break;
	
	case 73:
		printf("shortCutIsSafe: it %d, itnob %d, nbos %d, nsbor %d\n",
			iValue/1000, (iValue/100)%10, (iValue/10)%10, iValue%10 );
		break;
	
	case 74:
		printf("shortCutIsSafe: It' safe, ihsc %d\n", iValue );
		break;
	
	case 75:
		printf("isTheRailSorted: ihsc %d\n", iValue );
		break;
	
	case 76:
		printf("fhs: i %d, iws %d, ic %d\n", iValue/100, (iValue/10)%10, iValue%10);
		break;
	
	case 77:
		printf("isOKToMoveToRail: it %d, itnob %d, nbos %d, nsbor %d\n",
			iValue/1000, (iValue/100)%10, (iValue/10)%10, iValue%10 );
		break;
		
	
	default:
		printf("Unknown entry %d\n", iType );
	}
}

